#ifndef _FRUSTUM_H_
#define _FRUSTUM_H_

// trieda premennych a funkcii (objektov) pre Frustum Culling
// frustum - komoly ihlan (cast ihlana, ktora lezi medzi dvoma rovnobeznymi rovinami)
class CFrustum {
public:
 // konstruktor
 CFrustum() { proj[0]=1.0f; proj[4]=0.0f; proj[8]= 0.0f; proj[12]=0.0f;
              proj[1]=0.0f; proj[5]=1.0f; proj[9]= 0.0f; proj[13]=0.0f;
              proj[2]=0.0f; proj[6]=0.0f; proj[10]=1.0f; proj[14]=0.0f;
              proj[3]=0.0f; proj[7]=0.0f; proj[11]=0.0f; proj[15]=1.0f;
              modv[0]=1.0f; modv[4]=0.0f; modv[8]= 0.0f; modv[12]=0.0f;
              modv[1]=0.0f; modv[5]=1.0f; modv[9]= 0.0f; modv[13]=0.0f;
              modv[2]=0.0f; modv[6]=0.0f; modv[10]=1.0f; modv[14]=0.0f;
              modv[3]=0.0f; modv[7]=0.0f; modv[11]=0.0f; modv[15]=1.0f; }
 virtual ~CFrustum() {} // destruktor

 // inicializaica frustum - nacitanie prvkov projekcnej matice
 void init(void);
 // vypocet prvkov rovnic rovin frustum
 void update(void);
 // vykreslenie frustum
 void draw(void);

 // test polohy bodu voci frustum
 bool point_in_frustum(vec3 P);
 // test polohy trojuholnika voci frustum
 bool triangle_in_frustum(vec3 V0,vec3 V1,vec3 V2);
 // test polohy gule voci frustum
 bool sphere_in_frustum(vec3 P,GLfloat R);
 // test polohy kocky voci frustum
 bool cube_in_frustum(vec3 P,GLfloat S);
 bool cube_in_frustum(GLfloat MINX,GLfloat MAXX,
                      GLfloat MINY,GLfloat MAXY,
                      GLfloat MINZ,GLfloat MAXZ);
private:
 GLfloat proj[16]; // prvky projekcnej matice
 GLfloat modv[16]; // prvky modelview matice

 GLfloat clip[16];    // pomocne premenne pre vypocet prvkov rovnic rovin frustum
 GLfloat plane[6][4]; // 6x 0,1,2,3 - prvky 6-tich rovnic rovin frustum
};

#endif
