#ifndef _PLANTGRASS_H_
#define _PLANTGRASS_H_

// hranicny stvoruholnik obsahujuci travu,
// resp. 2 hranicne trojuholniky obsahujuce travu
struct grassquad
{
 vec3 v[4]; // vrcholy stvoruholnika, resp. vrcholy 2 trojuholnikov
};

// vzorky travy
struct grasssample
{
 float x,y,z;        // poloha vzorky
 float h;            // vyska vzorky
 unsigned char c[3]; // farba vzorky
};

// pole stvoruholnikov obsahujucich travu
struct grassarray
{
 vec3 T[2]; // tangenty trojuholnikov

 vector<grassquad> grassquads;     // zoznam stvoruholnikov
 vector<grasssample> grasssamples; // zoznam vzoriek
};

// trieda premennych a funkcii pre vytvorenie 3D travy
class CPlantgrass {
public:
 // konstruktor
 CPlantgrass();
 // destructor
 ~CPlantgrass();

 // vykreslenie travy
 int draw(vec3 AP,vec3 RV);
private:
 float gwidth,gheight; // sirka a vyska vzorky travy
 float ggrid;          // hustota vzoriek v hranicnom trojuholniku

 unsigned int numsamples; // aktualny pocet vzoriek travy

 float timeticks; // plynutie casu

 grassarray ga; // pole stvoruholnikov (trojuholnikov) obsahujucich travu

 vec3 cpos,crot; // poloha a natocenie kamery
 vec3 right;     // vektor smerujuci "doprava"

 vec3 vv,tg;             // pomocne vektory
 vec3 a1,a2,b1,b2,c1,c2; // pomocne vektory

 float dx,dy,dz,dd; // pomocne premenne
 float di,ld,w1,w2; // pomocne premenne

 // vypocet poloh jednotlivych vzoriek travy
 int SetGrassSamples(grassarray *ga,const vec3 *v,const int Tn);
 // vykreslenie vzoriek travy
 int RenderGrassSamples(grassarray *ga,const vec3 RV);
};

#endif
