#ifndef _FRONTEND_H_
#define _FRONTEND_H_

// trieda premennych a funkcii (objektov) pre rendering sceny
class CFrontend {
public:
 CFrontend();  // konstruktor
 ~CFrontend(); // destruktor

 // inicializacia vykreslovania
 void init(void);
 // vykreslenie vsetkych trojuholnikov
 void tris_draw(GLfloat FL,vec3 AP);

 // vykreslenie odrazenych trojuholnikov a zrkadiel
 int mirrors_on(GLfloat FL,vec3 AP);
 void mirrors_off(void);
private:
 // identifikator zakladnej textury a lightmapy
 GLuint base_tex_id,lm_tex_id;
 // modelview, projection, offset a texture matica
 mat16 MVmat,PRmat,MVoffset,Tmat;

 // pomocne premenne
 GLfloat d0,d1;
 GLint l0,l1,l2;

 // vykreslenie odrazenych trojuholnikov
 void draw_mtris(GLfloat FL,vec3 AP);
};

#endif
