!!ARBfp1.0

OPTION ARB_precision_hint_nicest;

PARAM lcolor=program.local[0];   # light color
PARAM ambient=state.lightmodel.ambient;
PARAM fl_onoff=program.local[1]; # flashlight on/off

TEMP bac,lmc,flc,diffuse,d1,d2,d3;
TEMP tex_normal,dir,light_dir,eye_dir;

TEX bac,fragment.texcoord[0],texture[0],2D;        # base color
TEX lmc,fragment.texcoord[1],texture[2],2D;        # lightmap color
TXP flc,fragment.texcoord[2],texture[3],2D;        # flashlight color

TEX tex_normal,fragment.texcoord[0],texture[1],2D; # normalmap color
MAD tex_normal,tex_normal,2.0,-1.0;                # result=tex_normal*2.0-1.0
DP3 dir.w,tex_normal,tex_normal;                   # normalize the normal map
RSQ dir.w,dir.w;
MUL tex_normal,tex_normal,dir.w;

#DP3 dir.w,fragment.texcoord[6],fragment.texcoord[6]; # normalize eye vector
#RSQ dir.w,dir.w;
#MUL eye_dir,fragment.texcoord[6],dir.w;

DP3 dir.w,fragment.texcoord[3],fragment.texcoord[3]; # result.w=a^2+b^2+c^2
RSQ dir.w,dir.w;                                     # result.w=1/sqrt(a^2+b^2+c^2)
MUL light_dir,fragment.texcoord[3],dir.w;            # normalize
RCP dir.w,dir.w;                                     # result.w=1/a
MAD_SAT dir.w,dir.w,-0.05,1.0;                       # light1 attenuation

DP3_SAT d1,tex_normal,light_dir;
MUL d1,d1,dir.w;

DP3 dir.w,fragment.texcoord[4],fragment.texcoord[4]; # result.w=a^2+b^2+c^2
RSQ dir.w,dir.w;                                     # result.w=1/sqrt(a^2+b^2+c^2)
MUL light_dir,fragment.texcoord[4],dir.w;            # normalize
RCP dir.w,dir.w;                                     # result.w=1/a
MAD_SAT dir.w,dir.w,-0.05,1.0;                       # light2 attenuation

DP3_SAT d2,tex_normal,light_dir;
MUL d2,d2,dir.w;

DP3 dir.w,fragment.texcoord[5],fragment.texcoord[5]; # result.w=a^2+b^2+c^2
RSQ dir.w,dir.w;                                     # result.w=1/sqrt(a^2+b^2+c^2)
MUL light_dir,fragment.texcoord[5],dir.w;            # normalize
RCP dir.w,dir.w;                                     # result.w=1/a
MAD_SAT dir.w,dir.w,-0.05,1.0;                       # light3 attenuation

DP3_SAT d3,tex_normal,light_dir;
MUL d3,d3,dir.w;

ADD_SAT diffuse,d1,d2;      # diffuse sum light1+light2
ADD_SAT diffuse,diffuse,d3; # diffuse sum +light3

MUL diffuse,diffuse,lcolor; # diffuse*=light color
MUL flc,flc,fl_onoff.x;
ADD diffuse,diffuse,flc;    # diffuse+=flashlight color

MUL diffuse,diffuse,bac;    # diffuse*=base color

MUL bac,bac,lmc;            # base color*=lightmap color
MUL bac,bac,0.5;

ADD_SAT result.color,bac,diffuse; # result.color=diffuse + base color

#MOV result.color,bac;

END